#ifndef LISTA_H
#define LISTA_H

using namespace std;

class Nodo{
	friend class Lista;

public:
	
	Nodo(){};
	int DevolverDato(){ return Dato;}
	int DevolverConteo(){ return Conteo;}

private:
	int Dato,Conteo;
	Nodo *SigNodo;
};

class Lista{

	
public:
	Lista();
	~Lista();
	
	void InsertarFrente(int);
	void InsertarFinal(int);
	void EliminarNodo(int);
	void RemoverFrente();
	void RemoverFinal();
	int EstaVacia(){return PtrFrente==NULL;};
	void ImprimirLista();
	
protected:
	Nodo *PtrFrente;
	Nodo *PtrFinal;

};

Lista::Lista():PtrFrente(NULL), PtrFinal(NULL){}

Lista::~Lista(){

	Nodo *Tmp;
		
	if(!EstaVacia()){
		while(PtrFrente!=NULL){

			Tmp=PtrFrente;
			PtrFrente=PtrFrente->SigNodo;
			cout<<"Borrando Dato..."<<Tmp->Dato;
			delete Tmp;
		}
	}
}

    
void Lista::InsertarFrente(int Info){

	Nodo *NuevoNodo= new Nodo;

	if(NuevoNodo==NULL)
		cout<<"Memoria Insuficiente...";
	else{
	NuevoNodo->Dato =Info;
		if(EstaVacia()){
			NuevoNodo->SigNodo =PtrFrente;
			PtrFrente=NuevoNodo;
			PtrFinal=NuevoNodo;
		}
		else{
			NuevoNodo->SigNodo =PtrFrente;
			PtrFrente=NuevoNodo;
			
		}

	}
	
}




void Lista::InsertarFinal(int Info){

		Nodo *NuevoNodo= new Nodo;

	if(NuevoNodo==NULL)
		cout<<"Memoria Insuficiente...";
	else{
	NuevoNodo->Dato =Info;
		if(EstaVacia()){
		
			NuevoNodo->SigNodo =PtrFrente;
			PtrFrente=NuevoNodo;
			PtrFinal=NuevoNodo;
			
		}
		else{
			PtrFinal->SigNodo =NuevoNodo;
			NuevoNodo->SigNodo =NULL;
			PtrFinal=NuevoNodo;			
		}

	}
}

void Lista::RemoverFrente(){

	Nodo *Tmp;

	if(EstaVacia())
		cout<<"La lista ya est vaca..."<<endl;
	else
	{
		Tmp=PtrFrente;
		PtrFrente=PtrFrente->SigNodo;
		delete Tmp;
	}
}

void Lista::RemoverFinal(){

	Nodo *Tmp, *NodoABorrar;

	if(EstaVacia()){
		cout<<"La lista ya est vaca..."<<endl;
		}
	else
	{

		NodoABorrar=PtrFinal;
		Tmp=PtrFrente;

		if(PtrFrente==PtrFinal)
		PtrFrente=NULL;

		else{
		
			while(Tmp->SigNodo !=PtrFinal)
			Tmp=Tmp->SigNodo;
								
			PtrFinal=Tmp;
			PtrFinal->SigNodo =NULL;
		}
		delete NodoABorrar;
	}
}


void Lista::EliminarNodo(int Info){

	int Encontrado;
	Encontrado=0;

	Nodo *NodoABorrar;
	Nodo *NodoAnterior;
	
	NodoABorrar=PtrFrente;
	NodoAnterior=PtrFrente;

if (!EstaVacia()){

		if(PtrFrente->Dato ==Info){
			PtrFrente=PtrFrente->SigNodo;
			delete NodoABorrar;
		}

		else if(PtrFinal->Dato ==Info){

			while(NodoABorrar->SigNodo !=PtrFinal)
				NodoABorrar=NodoABorrar->SigNodo;
				
			PtrFinal=NodoABorrar;
			NodoABorrar=PtrFinal->SigNodo;
			PtrFinal->SigNodo =NULL;
			delete NodoABorrar;
			
		}

		else {

			
			while(NodoABorrar!=NULL){
				if(NodoABorrar->Dato !=Info){
				NodoAnterior=NodoABorrar;
				NodoABorrar=NodoABorrar->SigNodo;
				}

				else{
					Encontrado=1;
					break;}
			}

			if(Encontrado){
			NodoAnterior->SigNodo =NodoABorrar->SigNodo;
			delete NodoABorrar;
			}
		}
	}
else
	cout<<"La lista ya est vacia...";	
}

void Lista::ImprimirLista(){
	Nodo *NodoAMostrar;
	
	NodoAMostrar=PtrFrente;
	
    while(NodoAMostrar!=PtrFinal)
                             {
                             cout<<NodoAMostrar->Dato<<" ";
                             NodoAMostrar=NodoAMostrar->SigNodo;
                             }
    cout<<NodoAMostrar->Dato<<endl;
}


#endif
